public class TabTrie{
    private int[] tab;
    private int taille; //nombre d'elements stocks
    private int capacite; //nombre d'elements pouvant tre stocks
    private int increment;
    
    public TabTrie(){
	this(10,5);
    }
    
    public TabTrie(int capacite,int increment){
	this.capacite=capacite;
	this.increment=increment;
	this.taille=0;
	this.tab=new int[capacite];
    }

    public int getTaille(){
	return taille;
    }
    
    public int getIncrement(){
	return increment;
    }

    public void agrandir(){
	System.out.println("Agrandir");
	capacite+=increment;
	int[] newTab=new int[capacite];
	for(int i=0;i<taille;i++){
	    newTab[i]=tab[i];
	}
	this.tab=newTab;
    }
	
    public void diminuer(){
	System.out.println("Diminuer");
	capacite-=increment;
	int[] newTab=new int[capacite];
	for(int i=0;i<taille;i++){
	    newTab[i]=tab[i];
	}
	this.tab=newTab;
    }

    public void inserer(int entier){
	if(taille+1>capacite){
	    agrandir();
	}
	int i=taille-1;
	while(i>=0 && tab[i]>entier){
	    tab[i+1]=tab[i];
	    i--;
	}
	tab[i+1]=entier;
	taille++;
    }

    public void retirer(int entier){
	int i=0;
	while(i<taille && tab[i]!=entier){
	    i++;
	}
	if(i<taille){//L'lment est prsent
	    for(;i<taille-1;i++){
		tab[i]=tab[i+1];
	    }
	    taille--;
	    if(capacite-taille>2*increment){
		diminuer();
	    }
	}
    }

    @Override
    public String toString(){
	String str="[taille = "+Integer.toString(taille)+", capacite = "+Integer.toString(capacite)+"] \n  Tab = ";
	for(int i=0;i<taille;i++){
	     str = str+Integer.toString(tab[i]) + " ";
	}
	return str;
    }

}
